// Copyright 2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Users/Omni/bungi/Library/TimCVS/Tim/Altivec/Julia/OmniJulia/JuliaView.h,v 1.3 2000/10/15 06:59:38 bungi Exp $

#import <AppKit/AppKit.h>
#import <CoreGraphics/CGDirectDisplay.h>

#import "Worker.h"
#import "ScreenSaver.h"
#import "julia.h"

typedef struct _JuliaInterest {
    unsigned int visitations   : 31;
    unsigned int isInteresting : 1;
} JuliaInterest;

typedef struct _JuliaWorkBuffer {
    Worker           worker;

    // Info specific to this type of work
    unsigned int     pixelWidth, pixelHeight;
    color_t         *image;
    float            width, height;
    float            center[4];
    float            dx[4], dy[4];
    unsigned int     clutIndex;
    float            c[4];
    DistanceType     mandelbrotDistanceType;
} JuliaWorkBuffer;


@interface JuliaView : ScreenSaverView
{
    float c0[4];    /* The starting Julia set */
    float c1[4];    /* The ending Julia set */
    float  t;       /* From zero to one to interpolate between the julia sets */
    float  step;    /* The rate at which t changes. */

    unsigned int     pixelWidth, pixelHeight;

    JuliaWorkBuffer *workers;
    unsigned int     workerCount;
    unsigned int     workerIndex;
    
    float            currentAngle;
    Julia            testPoint;
    
    NSDictionary *originalMode;
    NSDictionary *saverMode;
}

- (BOOL) isStandalone;

@end
