// Copyright 2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Users/Omni/bungi/Library/TimCVS/Tim/Altivec/Julia/OmniJulia/Worker.h,v 1.2 2000/10/15 02:23:17 bungi Exp $

#import <pthread.h>

typedef enum _WorkerState {
    WorkerPendingState,
    WorkerBusyState,
    WorkerDoneState,
    WorkerStoppedState
} WorkerState;

struct _Worker;

typedef void (*WorkerFunction)(struct _Worker *worker);

typedef struct _Worker {
    pthread_mutex_t  mutex;
    pthread_cond_t   condition;
    pthread_t        thread;
    WorkerState      state;
    WorkerFunction   function;
} Worker;


extern void WorkerInit(Worker *worker, WorkerFunction function);
extern void WorkerDestroy(Worker *worker);

extern void WorkerStartBackgroundThread(Worker *worker);

extern void WorkerWaitForCompletion(Worker *worker);
extern void WorkerSignalMoreWork(Worker *worker);


