// Copyright 2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Users/Omni/bungi/Library/TimCVS/Tim/Altivec/Julia/OmniJulia/altivec.h,v 1.2 2000/10/15 02:23:17 bungi Exp $

#import <stdlib.h>

// For the easiest use, vector pointers need to be 128-bit aligned
// (16-byte aligned).  Since this is allocated on the stack we
// don't have to worry about the complexity of trying to free
// the returned pointer (which isn't always the one we allocated).

#define VEC_ALIGNMENT (16)

#define vec_alloca(result, size) \
do { \
    size_t paddedSize = size + VEC_ALIGNMENT; \
    void *mem; \
    unsigned int addr; \
 \
    mem = alloca(paddedSize); \
    addr = (unsigned int)mem; \
    if (addr & (VEC_ALIGNMENT - 1)) { \
        addr = (addr + VEC_ALIGNMENT) & ~(VEC_ALIGNMENT - 1); \
    } \
 \
    result = (typeof(result))addr; \
} while (0)
