// Copyright 2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Users/Omni/bungi/Library/TimCVS/Tim/Altivec/Julia/OmniJulia/ppc_asm_macros.h,v 1.2 2000/10/15 02:23:17 bungi Exp $



// Macros to help in loading 32-bit *DATA* addresses.  The high part
// must always be loaded first.  Instruction addresses must be done
// differently to generate the correct link edit info.
.macro lahi
        addis	$0,0,ha16($1)
.endmacro
.macro lalo
        lwz	$0,lo16($1)($0)
.endmacro

// Macros to help in setting a 32-bit *DATA* address.  This is
// unlike the above in that it doesn't actually load the data.
.macro ahi
        addis	$0,0,ha16($1)
.endmacro
.macro alo
        addi	$0,$0,lo16($1)
.endmacro

// Like the ahi/alo macros, excep this assumes you have a PICBASE
// define and a L_PicBase local to do position independant code.
// ( ***NOTE*** These don't work for some reason, but they can serve as a template)
.macro ahipic
        addis	$0, PICBASE, ha16( $1 - L_PicBase )
.endmacro
.macro alopic
        addi	$0, $0, lo16( $1 - L_PicBase )
.endmacro

//
// Macros for building register names from other integer defines
//
#define _REG(num)  r ## num
#define REG(num)   _REG(num)
#define _FREG(num) f ## num
#define FREG(num)  _FREG(num)

